import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JDialog.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.io.File.*;
import java.util.*;
import java.util.List;
import java.lang.Comparable;
import java.awt.FileDialog.*;


public class DTRS_Main implements ItemListener,ChangeListener{
    
    public static int decision = 1 ;
    public static Vector data_v = new Vector();
    public static Vector col_v = new Vector();
    Vector EClasses;
    public static EClass myClass[] = new EClass[1000];
    public static Region Positive = new Region("Positive") ;
    public static Region Negative = new Region("Negative") ;
    public static Region Boundary = new Region("Boundary") ;
    
    public static int numOfClass = 0 ;
    int sizeX = 1050;
    int sizeY = 600;
    public static int numOfObjects = 0 ;
    public static int numOfCols = 0 ;
    
    public static float PrA ;
    public static float alpha, beta ;
    public static float accuracy = 0;
    public static float precision = 0;
    
    Vector temp_v = new Vector();
    
    JFrame frame ;
    JFrame frame2 ;
    JFrame frame3 ;
    JFrame frame4 ;
    
    final static boolean shouldFill = true;
    final static boolean shouldWeightX = true;
    final static boolean RIGHT_TO_LEFT = false;
    static final int FPS_MIN = 0 ;
    static final int FPS_MAX = 100 ;
        
    JTable table;
    
    JMenuBar menuBar;
    JMenu menu,menu2;
    JMenuItem menuItem,menuItem2;
    
    public static JButton CalculateEC = new JButton("Calculate Equivalence Classes");
    public static JButton CalculateLF = new JButton("Recalculate Thresholds");
    public static JButton LearnButton = new JButton("Start GT Learning");
        
    FileDialog FD ;
    
    //private JPanel RegionPanel = new JPanel(new GridLayout(2,3));
    private JPanel RegionPanel = new JPanel(new GridLayout2(0,3,4,2));
    
    private JPanel LossPanel = new JPanel(new GridLayout(0,6));
    //private JPanel LossPanel = new JPanel(new GridBagLayout());
    private JPanel ThreshPanel = new JPanel(new GridLayout2(0,2,40,20));
    
    private JPanel ButtonPanel = new JPanel(new GridLayout2(0,1,4,2));
    //private JPanel InfoPanel = new JPanel(new BorderLayout());
    private JPanel InfoPanel = new JPanel(new GridLayout2(0,1,4,2));
    GridBagConstraints c = new GridBagConstraints();
    JPanel SliderPane = new JPanel(new GridLayout2(3,2,4,2));

    //private JPanel LossPanel = new JPanel(new GridBagLayout());
    //private JPanel LossPanel = new JPanel(new FlowLayout());

    private static JList PosL = new JList();
    private static JList NegL = new JList();
    private static JList BndL = new JList();

    private static JLabel Pos = new JLabel("Positive");
    private static JLabel Neg = new JLabel("Negative");
    private static JLabel Bnd = new JLabel("Boundary");

    private static JLabel Lalpha = new JLabel("\u03b1= ");
    private static JLabel Lbeta = new JLabel("\u03b2= ");
    private static JLabel LalphaV = new JLabel("0.0");
    private static JLabel LbetaV = new JLabel("0.0");

    public static float pp,pn ;
    public static float bp,bn ;
    public static float np,nn ;

    public static JLabel Lpp = new JLabel();
    public static JLabel Lpn = new JLabel();
    public static JLabel Lnp = new JLabel();
    public static JLabel Lnn = new JLabel();
    public static JLabel Lbp = new JLabel();
    public static JLabel Lbn = new JLabel();

    public static JTextField Tpp = new JTextField();
    public static JTextField Tpn = new JTextField();
    public static JTextField Tnp = new JTextField();
    public static JTextField Tnn = new JTextField();
    public static JTextField Tbp = new JTextField();
    public static JTextField Tbn = new JTextField();
    
    public static JLabel LAcc = new JLabel();
    public static JTextField TAcc = new JTextField();
    
    public static JLabel LPre = new JLabel();
    public static JTextField TPre = new JTextField();
    
    public JLabel decLabel = new JLabel();
    
    public JTextField dec = new JTextField();
    

    public static JTextArea ECLabel = new JTextArea("") ;
    private JPanel DebugPanel = new JPanel(new FlowLayout());

    //private JPanel DebugPanel = new JPanel(new GridLayout(0,2));
    private JPanel checkPanel = new JPanel(new GridLayout(0,1));
    private JPanel panel;
    
    JSlider framesPerSecond = new JSlider(JSlider.HORIZONTAL,FPS_MIN, FPS_MAX,0);
    JSlider framesPerSecond2 = new JSlider(JSlider.HORIZONTAL,FPS_MIN, FPS_MAX,0);
    JSlider framesPerSecond3 = new JSlider(JSlider.HORIZONTAL,FPS_MIN, FPS_MAX,0);
    JSlider framesPerSecond4 = new JSlider(JSlider.HORIZONTAL,FPS_MIN, FPS_MAX,0);
    JSlider framesPerSecond5 = new JSlider(JSlider.HORIZONTAL,FPS_MIN, FPS_MAX,0);
    JSlider framesPerSecond6 = new JSlider(JSlider.HORIZONTAL,FPS_MIN, FPS_MAX,0);
    
    
    JPanel RectPane = new JPanel();
    public static RegionDraw Rect = new RegionDraw();
    GraphPanel Graph ;
    public static GamePanel Game ;
    public static Game PayoffTable = new Game();
    
  public static void main(String[] args) {
      new FileUtil();
      new DTRS_Main();
  }

    public DTRS_Main(){
        frame = new JFrame("GTRS Analysis Tool");
        frame2 = new JFrame("Database");
        frame3 = new JFrame("Plots");
        frame4 = new JFrame("Game");
        CalculateEC.setSize(10,10);
        
        pp=nn=bp=bn=(float)0;
        pn=np=(float)4.0;
        bn=bp=(float)1.0;
        
        //frame.getContentPane().setLayout(new BorderLayout());
        //frame.getContentPane().setLayout(new GridLayout(0,1));
        frame.getContentPane().setLayout(new GridLayout(2,2,4,2));
        //frame.getContentPane().setLayout(new GridBagLayout());
        
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame2.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame3.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame4.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        alpha = (float)1.0 ;
        beta = (float)0.0 ;
        
        menuBar = new JMenuBar();
        menu = new JMenu("File");
       
        final FileDialog myFD = new FileDialog(frame, "Please choose a file", FileDialog.LOAD);
        menu.getAccessibleContext().setAccessibleDescription("The only menu in this program that has menu items");
        menuBar.add(menu);
        
        menuItem = new JMenuItem("Open Comma-Delimited File");
        menuItem.getAccessibleContext().setAccessibleDescription("This doesn't really do anything");
        menuItem.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                OpenTheFile(myFD);
            }
        });
        ECLabel.setText("");
        menu.add(menuItem);

//        menu2 = new JMenu("Attributes");
//        menuBar.add(menu2);
//        menu2.getAccessibleContext().setAccessibleDescription("The Select Attributes Menu");
//        menuItem2 = new JMenuItem("Select Attributes");
//        menuItem2.addActionListener(new ActionListener(){
//            public void actionPerformed(ActionEvent e)
//            {
//                SelectAttributes();
//            }
//        });
//        menu2.add(menuItem2);
        //frame.setMenuBar(menuBar);
        frame.setJMenuBar(menuBar);


        frame.setLocation(1,1);
        frame.setSize(sizeX,sizeY);

        frame.setVisible(true);
        //frame2.setLocation(1440,1);
        frame2.setLocation(1,1);
        
        UpdateThresh();
    }
    
    public static void UpdateThresh()
    {
        LalphaV.setText(""+alpha);
        LbetaV.setText(""+beta);
        Tpp.setText(""+pp); Tpn.setText(""+pn);
        Tbp.setText(""+bp); Tbn.setText(""+bn);
        Tnp.setText(""+np); Tnn.setText(""+nn);
    }
    
    public static void UpdateParams()
    {
        pp=Float.parseFloat(Tpp.getText());  pn=Float.parseFloat(Tpn.getText());
        bp=Float.parseFloat(Tbp.getText());  bn=Float.parseFloat(Tbn.getText());
        np=Float.parseFloat(Tnp.getText());  nn=Float.parseFloat(Tnn.getText());
        
        alpha = (pn-bn)/((bp-bn)-(pp-pn));
        beta = (bn-nn)/((np-nn)-(bp-bn));
        
        UpdateThresh();        
    }
    
    public void CalculateThresholds()
    {
        pp=Float.parseFloat(Tpp.getText());  pn=Float.parseFloat(Tpn.getText());
        bp=Float.parseFloat(Tbp.getText());  bn=Float.parseFloat(Tbn.getText());
        np=Float.parseFloat(Tnp.getText());  nn=Float.parseFloat(Tnn.getText());
        
        alpha = (pn-bn)/((bp-bn)-(pp-pn));
        //alpha=(float)0.75 ;
        beta = (bn-nn)/((np-nn)-(bp-bn));
        //beta=(float)0.2875 ;
        for(int i=0; i < this.numOfClass; i++)
            myClass[i].members.clear();
        this.numOfClass = 0 ;
        
        ECLabel.setText("");
        
        UpdateThresh();
    }
    
    public static void CalculateMeasures()
    {
        accuracy = (float)Positive.members.size() / (Positive.members.size() + Boundary.members.size());
        accuracy = (float)(Math.round(accuracy*100.0f)/100.0f);
        precision = (float)Positive.members.size() / numOfObjects ;
        precision = (float)(Math.round(precision*100.0f)/100.0f);
        //precision = (float)this.numOfObjects / (Positive.members.size() + Boundary.members.size()) ;
        TAcc.setText(""+accuracy);
        TPre.setText(""+precision);
    }
    
    public void addListeners()
    {
        dec.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                decision = Integer.parseInt(dec.getText());
            }
        });
        
        Tpp.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                UpdateParams();
            }
        });
        
        Tnp.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                UpdateParams();
            }
        });
        
        Tbp.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                UpdateParams();
            }
        });
        
        Tpn.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                UpdateParams();
            }
        });
        
        Tnn.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                UpdateParams();
            }
        });
        
        Tbn.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                UpdateParams();
            }
        });
    }
    
    public void SelectAttributes()
    {
        //System.out.println("SelectAttributes()");
        JCheckBox[] AttributeCheckBoxes = new JCheckBox[table.getColumnCount()];
        //JPanel checkPanel = new JPanel(new GridLayout(0, 1));
        
        for(int i=0; i < table.getColumnCount(); i++)
        {
            AttributeCheckBoxes[i] = new JCheckBox(table.getColumnName(i));
            System.out.println("Added a checkbox");
            //AttributeCheckBoxes[i].setSelected(true);
            AttributeCheckBoxes[i].addItemListener(this);
            //AttributeCheckBoxes[i].setBackground(Color.red);
            checkPanel.add(AttributeCheckBoxes[i]);
        }

        RegionPanel.add(Pos);
        RegionPanel.add(Neg);
        RegionPanel.add(Bnd);
        
        JScrollPane listScroller1 = new JScrollPane(PosL);;
        JScrollPane listScroller2 = new JScrollPane(NegL);
        JScrollPane listScroller3 = new JScrollPane(BndL);
        //listScroller1.setMaximumSize(new Dimension(250, 80));

        RegionPanel.add(listScroller1);
        RegionPanel.add(listScroller2);
        RegionPanel.add(listScroller3);
        //RegionPanel.setMaximumSize(new Dimension(200,200));
        
        Lpp.setText("\u03bb pp"); Lpp.setFont(new Font("Serif", Font.BOLD, 22));
        Lnp.setText("\u03bb np"); Lnp.setFont(new Font("Serif", Font.BOLD, 22));
        Lbp.setText("\u03bb bp"); Lbp.setFont(new Font("Serif", Font.BOLD, 22));
        Lpn.setText("\u03bb pn"); Lpn.setFont(new Font("Serif", Font.BOLD, 22));
        Lnn.setText("\u03bb nn"); Lnn.setFont(new Font("Serif", Font.BOLD, 22));
        Lbn.setText("\u03bb bn"); Lbn.setFont(new Font("Serif", Font.BOLD, 22));
        decLabel.setText("Decision");
        dec.setText(""+decision);
        Lalpha.setFont(new Font("Serif", Font.BOLD, 22));
        Lbeta.setFont(new Font("Serif", Font.BOLD, 22));
        
        ThreshPanel.add(Lalpha); ThreshPanel.add(LalphaV);
        ThreshPanel.add(Lbeta); ThreshPanel.add(LbetaV);
        
        Tpp.setPreferredSize(new Dimension(60,35));
        Tbp.setPreferredSize(new Dimension(60,35));
        Tnp.setPreferredSize(new Dimension(60,35));
        Tpn.setPreferredSize(new Dimension(60,35));
        Tbn.setPreferredSize(new Dimension(60,35));
        Tnn.setPreferredSize(new Dimension(60,35));
        
        addListeners();
     
        LossPanel.add(Lpp); LossPanel.add(Tpp);
        LossPanel.add(Lnp); LossPanel.add(Tnp);
        LossPanel.add(Lbp); LossPanel.add(Tbp);
        LossPanel.add(Lpn); LossPanel.add(Tpn);
        LossPanel.add(Lnn); LossPanel.add(Tnn);
        LossPanel.add(Lbn); LossPanel.add(Tbn);
        LossPanel.add(this.decLabel); LossPanel.add(dec);
        
        LAcc.setText("Accuracy"); TAcc.setText("");
        LossPanel.add(LAcc); LossPanel.add(TAcc);
        
        LPre.setText("Precision"); TPre.setText("");
        LossPanel.add(LPre); LossPanel.add(TPre);
      
        
        //DebugPanel.add(checkPanel);
         
        //ButtonPanel.add(CalculateEC);
        ButtonPanel.add(CalculateLF);
        ButtonPanel.add(LearnButton);
        //DebugPanel.add(ThreshPanel);
        //DebugPanel.add(ButtonPanel);
        //DebugPanel.add(LossPanel);
        
        InfoPanel.add(ThreshPanel,BorderLayout.PAGE_START);
        InfoPanel.add(LossPanel,BorderLayout.CENTER);
        InfoPanel.add(ButtonPanel,BorderLayout.PAGE_END);
        //InfoPanel.setBorder(new EtchedBorder());
        //frame.setSize(50,50);
        CalculateEC.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                findEquivalenceClasses(data_v);
            }
        });
        
        CalculateLF.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                CalculateThresholds();
                findEquivalenceClasses(data_v);
                CalculateMeasures();
            }
        });
        
        LearnButton.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                PayoffTable.ChangeLoss(3,1);
                PayoffTable.ChangeLoss(3,2);
                PayoffTable.ChangeLoss(6,1);
                PayoffTable.ChangeLoss(6,2);
                PayoffTable.ChangeLoss(9,1);
                PayoffTable.ChangeLoss(9,2);

            }
        });
        //frame.getContentPane().add(DebugPanel);
        
        frame.getContentPane().add(InfoPanel);
      
        //DebugPanel.setBounds(sizeX-200,sizeY-200,200,200);
        
        //DebugPanel.setSize(200,200);
        ECLabel.setOpaque(true);
        JScrollPane pScroll = new JScrollPane(ECLabel);
        //panel =  new JPanel(new GridLayout(3,1));
        panel =  new JPanel(new GridLayout2(2,1,4,2));
        //panel =  new JPanel(new FlowLayout());
        //panel =  new JPanel();
        
        //panel =  new JPanel(new FlowLayout());
        //panel =  new JPanel();
        //panel.setSize(new Dimension(500,20));
        Game = new GamePanel();
        Game.setPreferredSize(new Dimension(10,100));
        //frame4.getContentPane().add(Game);
        //frame4.setLocation(1052,1);
        //frame4.setSize(300,300);
        //frame4.setVisible(true);
        //frame4.show();
        panel.add(Rect);
        panel.add(Game);
        //Graph = new GraphPanel();
        //panel.add(Graph);
        //panel.add(ECLabel);
        //panel.add(pScroll);
        //ECLabel.add(pScroll);
        //frame.getContentPane().add(ECLabel);
        
        frame.getContentPane().add(panel);
        //panel.setSize(new Dimension(500,20));
        //RegionPanel.setBackground(new Color(250,0,0));
        //RegionPanel.setPreferredSize(new Dimension(500,150));
        frame.getContentPane().add(RegionPanel);
        //frame.getContentPane().add(LossPanel);
        //frame.pack();
        frame.show();
    }
    
    public void itemStateChanged(ItemEvent e) {
    }
    
    public void OpenTheFile(FileDialog myFD)
    {
        int arrlen = 10000;
        byte[] infile = new byte[arrlen];
        double widthT ;
        double heightT ;
                
        myFD.show();
        String selectedItem = myFD.getFile();
        
	if (selectedItem == null) {
		// no file selected
	} else {
            File ffile = new File( myFD.getDirectory() + File.separator +
                    myFD.getFile());
            // read the file
            //System.out.println("reading file " + myFD.getDirectory() +
            //                         File.separator + myFD.getFile() );

            File myFile = new File(""+myFD.getDirectory()+File.separator + myFD.getFile());
            Vector v = fileToVector(myFile);
            
            DefaultTableModel model = new DefaultTableModel();
            JPanel panel = new JPanel();
            
            //Collections.sort(data_v, new ListComparator(1, true));
            
            
            //findEquivalenceClasses(data_v);

            Vector tempVec = new Vector();
            tempVec = createObjectVector();
            //System.out.println(""+tempVec);
            
            Vector fullVec = new Vector();
            fullVec = (Vector)data_v.clone();
            //System.out.println("vector: "+fullVec.get(2));
            //fullVec.addAll(0,tempVec);
            
            table = new JTable(model);
            
            //System.out.println("labels: "+col_v.get(4));
            
            
            model.setDataVector(data_v,col_v);
            numOfCols = col_v.size();
            model.addColumn("Object",tempVec);
            
            int src = table.getColumnCount()-1;
            table.moveColumn(src,0);
            numOfObjects = table.getRowCount();
            //System.out.println("Objects: "+numOfObjects);
            
            
            JTableHeader header = table.getTableHeader();
            
            header.setBackground(Color.LIGHT_GRAY);
            JScrollPane pane = new JScrollPane(table);
            widthT = header.getWidth() + table.getWidth();
            heightT = header.getHeight() + table.getHeight();
            Dimension dd = new Dimension((int)widthT-20, (int)heightT+6);
            
            //System.out.println("Table Width = "+table.getWidth());
            //System.out.println("Table Height = "+table.getHeight());
            
            //frame2.setSize(dd);
            frame2.getContentPane().add(pane);
            frame2.pack();
            frame2.setVisible(true);
            frame2.show();

            //SliderPane.setLayout(new BoxLayout(SliderPane,BoxLayout.Y_AXIS));
            SliderPane.setPreferredSize(new Dimension(100,100));
            addSliders();
            //Rect.setMaximumSize(new Dimension(300,200));
            //SliderPane.add(Rect);
            
            frame.getContentPane().add(SliderPane);
            
            //frame.getContentPane().add(panel);
            frame.setVisible(true);
            
            //Set Bounds for Panel with Table Dimensions
            SelectAttributes();
	}		
    }

    void addSliders()
    {
        // Slider Lpp
        framesPerSecond.addChangeListener(this) ;
        framesPerSecond.setMajorTickSpacing(10);
        framesPerSecond.setMinorTickSpacing(5);
        framesPerSecond.setPaintTicks(true);
        framesPerSecond.setName("Lpp");
        //framesPerSecond.setMaximumSize(new Dimension(300,50));
        framesPerSecond.setMaximumSize(new Dimension(300,50));
        //framesPerSecond.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(Color.red),framesPerSecond.getBorder()));
        //Create the label table
        Hashtable labelTable = new Hashtable();
        labelTable.put( new Integer( 0 ), new JLabel("\u03bb pp") );
        labelTable.put( new Integer( FPS_MAX/2 ), new JLabel("5") );
        labelTable.put( new Integer( FPS_MAX ), new JLabel("10") );
        framesPerSecond.setLabelTable( labelTable );
        framesPerSecond.setPaintLabels(true);
        framesPerSecond.setValue((int)(Float.parseFloat((String)Tpp.getText())*10));
        
        //Tpp.setText(Float.toString((float)fps/10));
        
        SliderPane.add(framesPerSecond);
        
        SliderPane.add(Box.createRigidArea(new Dimension(0,25)));
       
        // Slider Lnp
        framesPerSecond2.addChangeListener(this) ;
        framesPerSecond2.setMajorTickSpacing(10);
        framesPerSecond2.setMinorTickSpacing(5);
        framesPerSecond2.setPaintTicks(true);
        framesPerSecond2.setName("Lnp");
        framesPerSecond2.setMaximumSize(new Dimension(300,50));
        //Create the label table
        Hashtable labelTable2 = new Hashtable();
        labelTable2.put( new Integer( 0 ), new JLabel("\u03bb np") );
        labelTable2.put( new Integer( FPS_MAX/2 ), new JLabel("5") );
        labelTable2.put( new Integer( FPS_MAX ), new JLabel("10") );
        framesPerSecond2.setLabelTable( labelTable2 );
        framesPerSecond2.setPaintLabels(true);
        framesPerSecond2.setValue((int)(Float.parseFloat((String)Tnp.getText())*10));
        SliderPane.add(framesPerSecond2);
        
        SliderPane.add(Box.createRigidArea(new Dimension(0,25)));
        
        // Slider Lbp
        framesPerSecond3.addChangeListener(this) ;
        framesPerSecond3.setMajorTickSpacing(10);
        framesPerSecond3.setMinorTickSpacing(5);
        framesPerSecond3.setPaintTicks(true);
        framesPerSecond3.setName("Lbp");
        framesPerSecond3.setMaximumSize(new Dimension(300,50));
        //Create the label table
        Hashtable labelTable3 = new Hashtable();
        labelTable3.put( new Integer( 0 ), new JLabel("\u03bb bp") );
        labelTable3.put( new Integer( FPS_MAX/2 ), new JLabel("5") );
        labelTable3.put( new Integer( FPS_MAX ), new JLabel("10") );
        framesPerSecond3.setLabelTable( labelTable3 );
        framesPerSecond3.setPaintLabels(true);
        framesPerSecond3.setValue((int)(Float.parseFloat((String)Tbp.getText())*10));
        SliderPane.add(framesPerSecond3);
        
        SliderPane.add(Box.createRigidArea(new Dimension(0,25)));
        
        // Slider Lpn
        framesPerSecond4.addChangeListener(this) ;
        framesPerSecond4.setMajorTickSpacing(10);
        framesPerSecond4.setMinorTickSpacing(5);
        framesPerSecond4.setPaintTicks(true);
        framesPerSecond4.setName("Lpn");
        framesPerSecond4.setMaximumSize(new Dimension(300,50));
        //Create the label table
        Hashtable labelTable4 = new Hashtable();
        labelTable4.put( new Integer( 0 ), new JLabel("\u03bb pn") );
        labelTable4.put( new Integer( FPS_MAX/2 ), new JLabel("5") );
        labelTable4.put( new Integer( FPS_MAX ), new JLabel("10") );
        framesPerSecond4.setLabelTable( labelTable4 );
        framesPerSecond4.setPaintLabels(true);
        framesPerSecond4.setValue((int)(Float.parseFloat((String)Tpn.getText())*10));
        SliderPane.add(framesPerSecond4);
        
        SliderPane.add(Box.createRigidArea(new Dimension(0,25)));
        
        // Slider Lnn
        framesPerSecond5.addChangeListener(this) ;
        framesPerSecond5.setMajorTickSpacing(10);
        framesPerSecond5.setMinorTickSpacing(5);
        framesPerSecond5.setPaintTicks(true);
        framesPerSecond5.setName("Lnn");
        framesPerSecond5.setMaximumSize(new Dimension(300,50));
        //Create the label table
        Hashtable labelTable5 = new Hashtable();
        labelTable5.put( new Integer( 0 ), new JLabel("\u03bb nn") );
        labelTable5.put( new Integer( FPS_MAX/2 ), new JLabel("5") );
        labelTable5.put( new Integer( FPS_MAX ), new JLabel("10") );
        framesPerSecond5.setLabelTable( labelTable5 );
        framesPerSecond5.setPaintLabels(true);
        framesPerSecond5.setValue((int)(Float.parseFloat((String)Tnn.getText())*10));
        SliderPane.add(framesPerSecond5);
        
        SliderPane.add(Box.createRigidArea(new Dimension(0,25)));
        
        // Slider Lbn
        framesPerSecond6.addChangeListener(this) ;
        framesPerSecond6.setMajorTickSpacing(10);
        framesPerSecond6.setMinorTickSpacing(5);
        framesPerSecond6.setPaintTicks(true);
        framesPerSecond6.setName("Lbn");
        framesPerSecond6.setMaximumSize(new Dimension(300,50));
        //Create the label table
        Hashtable labelTable6 = new Hashtable();
        labelTable6.put( new Integer( 0 ), new JLabel("\u03bb bn") );
        labelTable6.put( new Integer( FPS_MAX/2 ), new JLabel("5") );
        labelTable6.put( new Integer( FPS_MAX ), new JLabel("10") );
        framesPerSecond6.setLabelTable( labelTable6 );
        framesPerSecond6.setPaintLabels(true);
        framesPerSecond6.setValue((int)(Float.parseFloat((String)Tbn.getText())*10));
        SliderPane.add(framesPerSecond6);
    }
    
    public void stateChanged(ChangeEvent e) {
        JSlider source = (JSlider)e.getSource();
        int fps = (int)source.getValue();
        if (source.getName() == "Lpp")
                Tpp.setText(Float.toString((float)fps/10));
        if (source.getName() == "Lnp")
                Tnp.setText(Float.toString((float)fps/10));
        if (source.getName() == "Lbp")
                Tbp.setText(Float.toString((float)fps/10));
        if (source.getName() == "Lpn")
                Tpn.setText(Float.toString((float)fps/10));
        if (source.getName() == "Lnn")
                Tnn.setText(Float.toString((float)fps/10));
        if (source.getName() == "Lbn")
                Tbn.setText(Float.toString((float)fps/10));
        
        UpdateParams();
        FindRegions();
        CalculateMeasures();
    }

    public static void Refresh()
    {
        UpdateParams();
        FindRegions();
        CalculateMeasures();
        //PayoffTable.ChangeLoss(3, 1);
    }
    
    public Vector createObjectVector()
    {
        Vector v = new Vector();
        for(int i=0; i <= data_v.lastIndexOf(data_v.lastElement()); i++)
        {
            //String s = "x".concat(Integer.toString(i));
            String s = Integer.toString(i);
            v.addElement(s);
        }
        return v;
    }
    
    private static Vector fileToVector (File file) {
	Vector v = new Vector(); 
        String s ;
        try
        {
            BufferedReader in = new BufferedReader(new FileReader(file));
            String str;
            int i =0;
            int j=0;
            while ((str = in.readLine()) != null)
            {
                StringTokenizer parser = new StringTokenizer(str,",");
                while (parser.hasMoreTokens())
                {
                    if(j==0)
                        col_v.addElement(parser.nextToken());
                    else  
                    {
                        s = parser.nextToken();
                        if(s.charAt(0)=='?')
                            v.addElement (new Integer(0));
                        else
                        //v.addElement (new Integer(Integer.parseInt(parser.nextToken())));
                            v.addElement (new Integer(s));
                    }
                    i=i+1;
                }
                
                if(j!=0)
                    data_v.addElement(v);
                v=new Vector();
                j++;
            }
            in.close();

	} catch(IOException event) {
	    System.err.println("can't open file" + event);
	    System.exit(0);
	} 
	return v ; 
    }
    
    public void addColumns(String[] colName)//Table Columns
    {
        for(int i=0;i<colName.length;i++)
            col_v.addElement((String) colName[i]);
    }
    
    public void addRows(String[][] rowData)
    {
        Vector newR = new Vector();
        
        for(int i=0; i < rowData.length;i++)
        {
            newR = populateSingleVector(rowData, i);
            data_v.addElement(newR);
        }
        
    }

    public void addRow() //Add Row
    {
        Vector r=new Vector();
        r=createBlankElement();
        data_v.addElement(r);
        //table.addNotify();
    }

    public Vector populateSingleVector (String[][] input, int row)
    {
        Vector t = new Vector();
        for(int i=0; i < col_v.lastIndexOf(col_v.lastElement()) + 1; i++)
        {
            t.addElement(new Integer(Integer.parseInt(input[row][i])));
        }
        return t;
    }
    
    public Vector createBlankElement() 
    {
        Vector t = new Vector();
        t.addElement((String) " test");
        t.addElement((String) " ");
        t.addElement((String) " ");
        return t;
    }
    
    
    public void findEquivalenceClasses2(Vector data)
    {
        int currentClass = 1 ;
        int counter =0 ;
        int count =0 ;
        Vector EQ = new Vector() ;
        EClasses = new Vector();
        Vector current = new Vector();
        Vector parent = new Vector();
        Vector temp = data ;
        
        //int[] Visited = new int[data.lastIndexOf(data.lastElement())];
        
        //System.out.println(""+data.lastIndexOf(data.lastElement()));
        for(int i=0 ; i <= data.lastIndexOf(data.lastElement()); i++)
        {
            current = (Vector)data.get(i);
            List lstK = current.subList(0, current.lastIndexOf(current.lastElement())-1);
            //ECLabel.setText(""+ECLabel.getText()+"Key: "+lstK+"\n");
            //current = (Vector)current.subList(0, current.lastIndexOf(current.lastElement())).get(0);
            if(!alreadyAdded(EClasses,i))
            {
                EQ.addElement((String)Integer.toString(i));
                numOfClass++ ;
                myClass[counter] = new EClass(numOfClass);
                myClass[counter].addVector(current,numOfObjects,decision);
                //ECLabel.append(""+myClass[i].members.get(i)+"\n");
                for(int j=i+1; j <= data.lastIndexOf(data.lastElement()); j++)
                {
                    //if(!alreadyAdded())
//                    if(current.equals((Vector)data.get(j)) && i!=j)
//                    {
//                        EQ.addElement((String)Integer.toString(j));
//                        count++;
//                    }
                    parent = (Vector)data.get(j);
                    //System.out.println("Parent: "+myClass[i].members.get(0));
                    List lstP = parent.subList(0, parent.lastIndexOf(parent.lastElement())-1);
                    //ECLabel.setText(""+ECLabel.getText()+"Pointer: "+lstP+"\n");
                    if(lstK.equals((List)lstP) && i!=j)
                    {
                        EQ.addElement((String)Integer.toString(j));
                        myClass[counter].addVector(parent,numOfObjects,decision);
                        
                        count++;
                    }
                }
                counter++ ;
            }
            //System.out.println(""+current+" has "+count+" matches.");
            if(EQ.size() != 0) EClasses.addElement(EQ);
            //System.out.println(""+EQ);
            EQ = new Vector();//EQ.clear();  
            count = 0;
        }
        findProb();
        DrawClasses();
        FindRegions();
        
        //GraphPanel Graph = new GraphPanel();
        Graph = new GraphPanel();
        //frame.getContentPane().add(Graph);
        frame3.getContentPane().add(Graph);
        //frame3.setLocation(1,frame2.getHeight());
        //frame3.setLocation(1440,1);
        frame3.setLocation(1,1);
        frame3.setSize(450,500);
        Graph.GetData();
        Graph.repaint();
        //frame3.pack();
        frame3.setVisible(true);
        frame3.show();
        
                
        Game = new GamePanel();
        //frame.getContentPane().add(Graph);
        frame4.getContentPane().add(Game);
        //frame3.setLocation(1,frame2.getHeight());
        //frame4.setLocation(1052,1);
        frame4.setLocation(1,1);
        frame4.setSize(300,300);
        frame4.setVisible(true);
        frame4.show();
        
    }
     
    
    public void findEquivalenceClasses(Vector data)
    {
        int currentClass = 1 ;
        int counter =0 ;
        int count =0 ;
        Vector EQ = new Vector() ;
        EClasses = new Vector();
        Vector current = new Vector();
        Vector parent = new Vector();
        Vector temp = (Vector)data.clone() ;
        
        decision = Integer.parseInt(dec.getText());
        
        for(int i=0 ; i <= temp.lastIndexOf(temp.lastElement()); i++)
        {
            current = (Vector)temp.get(i);
           
            List lstK = current.subList(0, current.lastIndexOf(current.lastElement())-1);
            //System.out.println("Removed element"+temp.elementAt(i)+", i = "+i);
            
            
            EQ.addElement((String)Integer.toString(i));
            numOfClass++ ;
            myClass[counter] = new EClass(numOfClass);
            myClass[counter].addVector(current,numOfObjects,decision);
            
            for(int j=i+1; j <= temp.lastIndexOf(temp.lastElement()); j++)
            {
                parent = (Vector)temp.get(j);

                List lstP = parent.subList(0, parent.lastIndexOf(parent.lastElement())-1);

                if(lstK.equals((List)lstP) && i!=j)
                {
                    EQ.addElement((String)Integer.toString(j));
                    myClass[counter].addVector(parent,numOfObjects,decision);
                    //System.out.println("Removed element2 "+temp.elementAt(i)+", j = "+j);
                    temp.removeElementAt(j);
                    count++;
                }
            }
            counter++ ;
        
            if(EQ.size() != 0) EClasses.addElement(EQ);
            EQ = new Vector();//EQ.clear();  
            count = 0;
            //temp.removeElementAt(i);  
        }
        findProb();
        DrawClasses();
        FindRegions();
        
        //GraphPanel Graph = new GraphPanel();
        Graph = new GraphPanel();
        //frame.getContentPane().add(Graph);
        frame3.getContentPane().add(Graph);
        //frame3.setLocation(1440,1);
        frame3.setLocation(1,1);
        frame3.setSize(800,500);
        Graph.GetData();
        Graph.repaint();
        //frame3.pack();
        frame3.setVisible(true);
        frame3.show();
        
        //Game = new GamePanel();
        //frame4.getContentPane().add(Game);
        //frame4.setLocation(1052,1);
        //frame4.setSize(300,300);
        //frame4.setVisible(true);
        //frame4.show();
        
    }
    
    public static void FindRegions()
    {
        Positive.members.clear();
        Negative.members.clear();
        Boundary.members.clear();
        
        Positive.size=0;
        Negative.size=0;
        Boundary.size=0;
        
        for(int i=0 ; i < numOfClass ; i++)
        {
            if(myClass[i].CPr >= alpha)
                Positive.addClass(myClass[i]);
            else if(myClass[i].CPr <= beta)
                Negative.addClass(myClass[i]);
            else
                Boundary.addClass(myClass[i]);
        }
        //Positive.printRegion();
        PosL.setListData(Positive.members);
        //Negative.printRegion();
        NegL.setListData(Negative.members);
        //Boundary.printRegion();
        BndL.setListData(Boundary.members);
        
        Pos.setText("Positive ("+Positive.size+" cl,\n "+Positive.members.size()+" obj):");
        Neg.setText("Negative ("+Negative.size+" cl,\n "+Negative.members.size()+" obj):");
        Bnd.setText("Boundary ("+Boundary.size+" cl,\n "+Boundary.members.size()+" obj):");
        
        Rect.repaint();
    }
    
    private void findProb()
    {
        int dc = 0 ;
        int count = 0 ;
        for(int i=0 ; i < numOfObjects; i++)
        {
            dc = Integer.parseInt(table.getValueAt(i, table.getColumnCount()-1).toString());
            if(dc == decision)
            {
                count++ ;
            }
            //current = (Vector)data.get(i);
            //System.out.println("decision: "+dc);
        }
        
        PrA = (float)count / numOfObjects ;
        //System.out.println("P(A) =  "+PrA);
    }
    
    public void DrawClasses()
    {
        ECLabel.append("Number of EClasses: "+numOfClass+"\n");
        for(int j=0; j < numOfClass; j++)
        {
            ECLabel.append("Equivalence Class "+myClass[j].index+", P(A|[x]) = "+myClass[j].CPr+"\n");
            for(int i=0; i < myClass[j].size;i++)
            {
                ECLabel.append(""+myClass[j].members.get(i)+"\n");
            }
        }
    }
    
    
    public boolean alreadyAdded(Vector eclass, int i)
    {
        String s = String.valueOf(eclass);
        String r = "";
        String temp1 ="";
        
        for (int j = 0; j < s.length(); j ++) {
            if ((s.charAt(j) != '[')&&(s.charAt(j) != ']')) r += s.charAt(j);
        }
        r+=",";
        temp1 = " "+String.valueOf(i)+",";
        //if(r.indexOf(String.valueOf(i)) != -1) return true;
        if(r.indexOf(temp1) != -1) return true;
        else return false;
    }

   
}

