public class Game {
    
    /** Creates a new instance of Game */
    public static Payoff[][] table = new Payoff[3][3];
    public static float old = 0 ;
    public static float UP = (float)1.2, DOWN = (float)0.8;
    
    public Game() {
        for(int i=0; i < 3; i++)
        {
            for(int j=0; j < 3; j++)
            {
                table[i][j] = new Payoff();
            }
        }
    }
    //public static void Populate(int index, int player)
    public void Populate(int index, int player)
    {
        if(player==1)
        {
            switch(index){
                case 1:
                case 2:
                case 3: table[0][0].SetA(DTRS_Main.accuracy);
                        table[0][1].SetA(DTRS_Main.accuracy);
                        table[0][2].SetA(DTRS_Main.accuracy);
                        break ;
                case 4:
                case 5:
                case 6: table[1][0].SetA(DTRS_Main.accuracy);
                        table[1][1].SetA(DTRS_Main.accuracy);
                        table[1][2].SetA(DTRS_Main.accuracy);
                        break ;
                case 7:
                case 8:
                case 9: table[2][0].SetA(DTRS_Main.accuracy);
                        table[2][1].SetA(DTRS_Main.accuracy);
                        table[2][2].SetA(DTRS_Main.accuracy);
                        break ; 
                default:  System.out.println("Invalid index for GAME");
                            break ;
            }
        }
        else {
            switch(index){
                case 1:
                case 2:
                case 3: table[0][0].SetB(DTRS_Main.precision);
                        table[1][0].SetB(DTRS_Main.precision);
                        table[2][0].SetB(DTRS_Main.precision);
                        break ;
                case 4:
                case 5:
                case 6: table[0][1].SetB(DTRS_Main.precision);
                        table[1][1].SetB(DTRS_Main.precision);
                        table[2][1].SetB(DTRS_Main.precision);
                        break ;
                case 7:
                case 8:
                case 9: table[0][2].SetB(DTRS_Main.precision);
                        table[1][2].SetB(DTRS_Main.precision);
                        table[2][2].SetB(DTRS_Main.precision);
                        break ; 
                default:  System.out.println("Invalid index for GAME");
                            break ;
            }
        }
    }
    
    public void ChangeLoss(int index, int player)
    {
        switch(index){
            case 1:
            case 2:
            case 3: old = DTRS_Main.pn ; 
                    DTRS_Main.pn *= DOWN ;
                    DTRS_Main.Tpn.setText(""+DTRS_Main.pn);
                    // redo calcs for appoximation, and get the measures
                    DTRS_Main.Refresh();
                    // update the Payoff Table
                    Populate(index,player);
                    DTRS_Main.Game.Refresh();
                    // set loss back to original
                    DTRS_Main.pn = old ;
                    DTRS_Main.Tpn.setText(""+DTRS_Main.pn);
                    // redo calcs for appoximation, and get the measures
                    DTRS_Main.Refresh();
                    break ;
            case 4:
            case 5:
            case 6: old = DTRS_Main.np ;
                    DTRS_Main.np *= UP ;
                    DTRS_Main.Tnp.setText(""+DTRS_Main.np);
                    // redo calcs for appoximation, and get the measures
                    DTRS_Main.Refresh();
                    // update the Payoff Table
                    Populate(index,player);
                    DTRS_Main.Game.Refresh();
                    // set loss back to original
                    DTRS_Main.np = old ;
                    DTRS_Main.Tnp.setText(""+DTRS_Main.np);
                    // redo calcs for appoximation, and get the measures
                    DTRS_Main.Refresh();
                    break ;
            case 7:
            case 8:
            case 9: old = DTRS_Main.bp ;
                    DTRS_Main.bp *= UP ;
                    DTRS_Main.Tbp.setText(""+DTRS_Main.bp);
                    // redo calcs for appoximation, and get the measures
                    DTRS_Main.Refresh();
                    // update the Payoff Table
                    Populate(index,player);
                    DTRS_Main.Game.Refresh();
                    // set loss back to original
                    DTRS_Main.bp = old ;
                    DTRS_Main.Tbp.setText(""+DTRS_Main.bp);
                    // redo calcs for appoximation, and get the measures
                    DTRS_Main.Refresh();
                    break ;
            default:  System.out.println("Invalid index for GAME");
                        break ;
        }
    }
    
}
