import java.util.*;
import java.util.List;

public class Region {
    
    public int size ;
    public Vector members ;
    public String name ;
    
    /** Creates a new instance of Region */
    public Region(String s) {
        size = 0 ;
        members = new Vector() ;
        name = s ;
    }
    
    public void addClass(EClass EC)
    {
        size++ ;
        
        for(int i=0 ; i < EC.size; i++)
            members.addElement((Vector)EC.members.get(i));
        //System.out.println("Size: "+size+", Added: "+EC.index);
    }
    
    public void printRegion()
    {
        DTRS_Main.ECLabel.append(""+name+" Region: \n");
        for(int i=0; i < size; i++)
        {
            DTRS_Main.ECLabel.append("["+members.get(i)+"] ");
        }
        DTRS_Main.ECLabel.append("\n");
    }
    
}
